import shutil
from dataclasses import dataclass
from pathlib import Path

from karaokatalog.instructions.Instruction import Instruction


@dataclass(frozen=True)
class DeleteInstruction(Instruction):
    """
    Deletes the given path (might point to a file, a folder or a link), no questions asked.
    """

    path_to_delete: Path

    def __call__(self) -> None:
        try:
            self.path_to_delete.unlink()
        except IsADirectoryError:
            shutil.rmtree(self.path_to_delete)
